"spdest.fastw" <-
function(price1,ttime,niter=5) {
## fast weights for the fast algorithm in spdest()
## K are strike prices, ttime are transaction times, niter is nr. of iterations
## we start by producing list d
  d=list()
  for (cut in unique(price1)) {
    d=c(d,list(1-sort(ttime[(price1==cut)&(ttime<1)])))
#    d=c(d,list(sort(ttime[(price1==cut)&(ttime<1)])))
  }
  p=length(d)
  ni=as.integer(lapply(d,length))
  n=sum(ni)
## let us create the covariance matrix
  rw=matrix(rep(rep(1:p,ni),n),nrow=n)
  cl=matrix(rep(rep(1:p,ni),n),nrow=n,byrow=TRUE)
  cov=matrix(0,nrow=n,ncol=n)
  cov2=matrix(0,nrow=n,ncol=n)
  m=matrix(0,nrow=n,ncol=p)
  delta=matrix(0,nrow=p,ncol=p)
  delta[upper.tri(delta,diag=TRUE)]=1
  sigma=delta%*%t(delta)
  for (i in 1:p) {
    odi=sum(c(0,ni[0:(i-1)]))+1
    doi=sum(ni[1:i])
    m[odi:doi,i]=1
    for (j in 1:p) {
      ## submatrix (i,j) 
      odj=sum(c(0,ni[0:(j-1)]))+1
      doj=sum(ni[1:j])
      podm=pmin(matrix(as.matrix(d[[i]]),nrow=ni[i],ncol=ni[j]),matrix(as.matrix(d[[j]]),nrow=ni[i],ncol=ni[j],byrow=TRUE))
      cov[odi:doi,odj:doj]=sigma[i,j]*podm
      cov2[odi:doi,odj:doj]=podm
    }
  }
  ## minimize the trace
  wtr=rep(0,n)
#  wtr[1+cumsum(c(0,ni[1:(p-1)]))]=1
  wtr[cumsum(ni)]=1
  ## iterative minimization of the determinant
  ## first iteration
  w=wtr
  for (iter in 1:niter) {
    vm=t(m)%*%diag(w)%*%cov%*%diag(w)%*%m
    vminv=solve(vm)
    vmin2=matrix(rep(as.vector(matrix(rep(as.vector(vminv),rep(ni,p)),nrow=p,byrow=TRUE)),rep(ni,n)),nrow=n)
    vv=cov*vmin2
    vvinv=ginv(vv)
    ones=matrix(1,nrow=p)
    w = as.vector(vvinv %*% m %*% (solve( t(m) %*% vvinv %*% m ) ) %*% ones) 
  }
  return(list(w=t(m*w)))
}

